
#include "..\dtc2.h"

#undef  M401TRC
#define DEBUG

typedef enum { sStart,sEnd,sData,sBlock,sSymb,sComm,sNorec } rectyp;
unsigned long _mflag[5] = {
	0x00000l,	/* X */
	0x10000l,	/* Y */
	0x20000l,	/* P */
	0x40000l,
	0x80000l
	};

extern unsigned long *DSPBUF;

/* ----------------------------------------------------------------- */
/*	LOD file read						     */
/* ----------------------------------------------------------------- */

static rectyp findkeyw (char *t)
{
 char typessym[6][12] =
      { "START","END","DATA","BLOCKDATA","SYMBOL","COMMENT" };
 int i,found;

  found=0;
  for (i=0; (i<6)&&(!found); i++) {
    found = !stricmp(t,typessym[i]);
   }
  if (!found) return(sNorec);
   else return((rectyp)(i-1));
}


int load56(char *fname)
{
 char t[81];
 int i;
 rectyp blktype = sNorec;
 char mspace[3];
 unsigned int len;
 unsigned long *buf=DSPBUF;
 long start,V;
 FILE *fp;

  if ((fp = fopen(fname,"rt")) == NULL) return(1);
  printf("Loading DSP file %s...",fname);
  memset(DSPBUF,0xff,DBUFSIZ*sizeof(long));

#ifdef DEBUG
  fprintf(stderr,"\n");
#endif
  do {
   if (fscanf(fp,"%s",t)==1) {
     if (*t == '_') {
       blktype = findkeyw(&(t[1]));
       switch (blktype) {
	 case sData:
	     fscanf(fp,"%s",mspace);
	     fscanf(fp,"%4lX",&start);
	     len=0; i=1;
	     buf=DSPBUF+start;
	     while (i) {
	       i = fscanf(fp,"%6lX",&V);
	       if ((toupper(*mspace)=='P') && i) { *buf++=V; len++; }
	      }
#ifdef DEBUG
	     fprintf(stderr,"\tblk %c:%04lx l=%x\n",*mspace,start,len);
#endif
	     break;
	 case sBlock:
	     fscanf(fp,"%s",mspace);
	     fscanf(fp,"%4lX",&start);
	     fscanf(fp,"%4x",&len);
	     fscanf(fp,"%6lX",&V);
	     if (toupper(*mspace)=='P') {
	       buf=DSPBUF+start;
#ifdef DEBUG
	       fprintf(stderr,"\tfill %06lx %c:%04lx l=%x\n",V,*mspace,start,len);
#endif
	       for (i=0; i<len; i++) *buf++=V;
	      }
	     break;
	 default: break;
	}
      }
    }
  } while (!(feof(fp) || (blktype==sEnd)));
 fclose(fp);
 printf("Ok\n");
 return(0);
}


/* ------------------------------------------------------------------- */


void dspwrite(unsigned long v)
{
  while((inp(HI_ISR)&2)==0);
  asm {	mov	dx,345h;
	mov	ax,word ptr v+2;
	out	dx,al;
	mov	ax,word ptr v;
	xchg	al,ah;
	inc	dx;
	out	dx,al;
	xchg	al,ah;
	inc	dx;
	out	dx,al;
      }
}


void dspwrite8(unsigned v)
{
  while((inp(HI_ISR)&2)==0);
  asm {	mov	dx,347h;
	mov	ax,word ptr v;
	out	dx,al;
      }
}


int dspwrite_t(unsigned long v,long t)
{
  while (((inp(HI_ISR)&2)==0)&&(--t)); if (t==0) return(1);
  asm {	mov	dx,345h;
	mov	ax,word ptr v+2;
	out	dx,al;
	mov	ax,word ptr v;
	xchg	al,ah;
	inc	dx;
	out	dx,al;
	xchg	al,ah;
	inc	dx;
	out	dx,al;
      }
  return(0);
}


static int near dspIswrite(long t)
{
  while (((inp(HI_ISR)&2)==0)&&(--t));
  return(t==0);
}


long dspread(void)
{
 long v;

  while((inp(HI_ISR)&1)==0);
  asm {	mov	dx,345h;
	in	al,dx;
	xor	cx,cx;
	mov	cl,al;
	inc	dx;
	in	al,dx;
	mov	ah,al;
	inc	dx;
	in	al,dx;
	mov	word ptr v,ax;
	mov	word ptr v+2,cx;
       }
  return(v);
}


long dspread_t(long t)
{
 long v;

  while (((inp(HI_ISR)&1)==0)&&(--t)); if (t==0) return(-1l);
  asm {	mov	dx,345h;
	in	al,dx;
	xor	cx,cx;
	mov	cl,al;
	inc	dx;
	in	al,dx;
	mov	ah,al;
	inc	dx;
	in	al,dx;
	mov	word ptr v,ax;
	mov	word ptr v+2,cx;
       }
  return(v);
}


static int near dspIsread(long t)
{
  while (((inp(HI_ISR)&1)==0)&&(--t));
  return(t==0);
}


static void near DSPcommand(int c)
{
  while (inp(HI_CVR)&0x80);
  outp(HI_CVR,(c|0x80));
  while (inp(HI_CVR)&0x80);
}


static long DSPpeek(int s,unsigned int a)
{
  DSPcommand(HC_Peek);
  dspwrite(_mflag[s]|a);
  dspwrite(1);
  return(dspread());
}


static unsigned long *DSPblkpeek(int s,unsigned int a,int n,unsigned long *buf)
{
 unsigned long *p = buf;

  DSPcommand(HC_Peek);
  dspwrite(_mflag[s]|a);
  dspwrite(n);
  while (n--) *p++ = dspread();
  return(buf);
}


static void DSPpoke(int s,unsigned int a,long v)
{
  DSPcommand(HC_Poke);
  dspwrite(_mflag[s]|a);
  dspwrite(1);
  dspwrite(v);
}


static void DSPfill(int s,unsigned int a,int n,long v)
{
  DSPcommand(HC_Fill);
  dspwrite(_mflag[s]|a);
  dspwrite(n);
  dspwrite(v);
}


int bootDSP(char *fname)
{
 int n,t;
 unsigned long *p;
 unsigned long v;

  if (load56(fname)) return(1);
  outportb(oDMODE,0);
  outportb(oDRES,0);	/* reset DSP  */
  delay(100);
  outportb(oDRES,1);	/* start DSP  */

  p = DSPBUF;
  for (n=0; n<512; n++) {
    v=*p++;
    t=10000; while (((inp(HI_ISR)&2)==0) && (--t));
    if (t==0) { printf("#%d\n",n); return(1); }
    outp(HI_TXM,(v>>8)); outp(HI_TXM,(v>>8));
    outp(HI_TXH,(v>>16)); outp(HI_TXH,(v>>16));
    outp(HI_TXL,v);
   }
  delay(1);	/* wait for DSP to reinitialize */
  return(0);
}


/* ----------------------------------------------------------------- */


int DSPview(void)
{
 char cmlin[128];
 char *p;
 int i,j,ms,n,err;
 unsigned long a,v;

  for (;;) {
    printf(">");
    gets(cmlin);
    p=cmlin; while(isspace(*p)) p++;
    switch(tolower(*p++)) {
      case 'q': return(0);
      case 'i': while (isspace(*p)) p++;
		err=0;
		switch(tolower(*p++)) {
		  case 'x': ms=0; break;
		  case 'y': ms=1; break;
		  case 'p': ms=2; break;
		  default:  err=1;
		 }
		if (*p==':') p++; else err=1;
		if (!err) {
		  if (sscanf(p,"%lx",&a)==1) {
		    v = (DSPpeek(ms,a)&0xffffff);
		   }
		  else err=1;
		 }
		if (err) printf("ERR\n");
		 else printf("%06lx\n",v);
		break;
      case 'd': while (isspace(*p)) p++;
		err=0;
		switch(tolower(*p++)) {
		  case 'x': ms=0; break;
		  case 'y': ms=1; break;
		  case 'p': ms=2; break;
		  default:  err=1;
		 }
		if (*p==':') p++; else err=1;
		if (!err) {
		  err=1;
		  if (sscanf(p,"%lx",&a)==1) {
		    while ((*p)&&(!isspace(*p))) p++;
		    while ((*p)&&(isspace(*p))) p++;
		    if ((*p==0)||(sscanf(p,"%x",&n)!=1)) n=64;
		    err=0;
		   }
		 }
		if (err) printf("ERR\n");
		 else {
		   DSPblkpeek(ms,a,n,DSPBUF);
		   i=0; j=0;
		   while (n--) {
		     if (j==0) printf("%04x:",a);
		     printf(" %06lx",DSPBUF[i++]&0xffffff);
		     j++; a++;
		     if (j==8) { printf("\n"); j=0; }
		    }
		  }
		break;
      case 'o': while (isspace(*p)) p++;
		err=0;
		switch(tolower(*p++)) {
		  case 'x': ms=0; break;
		  case 'y': ms=1; break;
		  case 'p': ms=2; break;
		  default:  err=1;
		 }
		if (*p==':') p++; else err=1;
		if (!err) {
		  err=1;
		  if (sscanf(p,"%lx",&a)==1) {
		    while (!isspace(*p)) p++;
		    while (isspace(*p)) p++;
		    if (sscanf(p,"%lx",&v)==1) err=0;
		   }
		 }
		if (err) printf("ERR\n");
		 else DSPpoke(ms,a,v);
		break;
      case 'f': while (isspace(*p)) p++;
		err=0;
		switch(tolower(*p++)) {
		  case 'x': ms=0; break;
		  case 'y': ms=1; break;
		  case 'p': ms=2; break;
		  default:  err=1;
		 }
		if (*p==':') p++; else err=1;
		if (!err) {
		  err=1;
		  if (sscanf(p,"%lx",&a)==1) {
		    while ((*p)&&(!isspace(*p))) p++;
		    while ((*p)&&(isspace(*p))) p++;
		    if (sscanf(p,"%lx",&v)==1) {
		      err=0;
		      while ((*p)&&(!isspace(*p))) p++;
		      while ((*p)&&(isspace(*p))) p++;
		      if ((*p==0)||(sscanf(p,"%x",&n)!=1)) n=1;
		     }
		   }
		 }
		if (err) printf("ERR\n");
		 else DSPfill(ms,a,n,v);
		break;
      default:  printf("<I>nput s:addr       <O>utput s:addr val\n");
		printf("<D>ump s:addr n      <F>ill s:addr val n\n");
		break;
     }
   }
}


/* ----------------------------------------------------------------- */

